class StatisticsPooling(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  def forward(self: __torch__.speechbrain.nnet.pooling.StatisticsPooling,
    argument_1: Tensor,
    lengths: Tensor) -> Tensor:
    _0 = torch.select(lengths, 0, 0)
    _1 = ops.prim.NumToTensor(torch.size(argument_1, 1))
    actual_size = torch.to(torch.round(torch.mul(_0, _1)), 3)
    _2 = int(actual_size)
    _3 = int(actual_size)
    _4 = torch.slice(torch.select(argument_1, 0, 0), 0, 0, _3)
    _5 = torch.mean(_4, [0])
    _6 = torch.slice(torch.select(argument_1, 0, 0), 0, 0, _2)
    _7 = torch.std(_6, [0])
    mean = torch.stack([_5])
    std = torch.stack([_7])
    _8 = ops.prim.NumToTensor(torch.size(mean, 0))
    _9 = int(_8)
    _10 = ops.prim.NumToTensor(torch.size(mean, 1))
    gnoise = torch.randn([_9, int(_10)], dtype=None, layout=None, device=torch.device("cuda:0"), pin_memory=False)
    gnoise0 = torch.sub_(gnoise, torch.min(gnoise))
    gnoise1 = torch.div_(gnoise0, torch.max(gnoise0))
    _11 = torch.add(torch.mul(gnoise1, CONSTANTS.c10), CONSTANTS.c11)
    gnoise2 = torch.mul(_11, CONSTANTS.c12)
    mean0 = torch.add_(mean, gnoise2)
    std0 = torch.add(std, CONSTANTS.c12)
    pooled_stats = torch.cat([mean0, std0], 1)
    return torch.unsqueeze(pooled_stats, 1)
